//+------------------------------------------------------------------+
//|                                         Slope_RB_EA_V3.mq4 |
//|                            Rogrio Borges, Copyright 2016        |
//|                                          rogeriob28@gmail.com    | 
//+------------------------------------------------------------------+
#property copyright "Rogerio Borges,Copyright 2016"
#property link      "rogeriob28@gmail.com"

extern string Comentario = "Slope EA V3 ";
extern string S1="----Slope Entry Settings";
extern int period=10; 
extern int method=3; // MODE_SMA 
extern int price=0; // PRICE_CLOSE 
extern string EA_Texto8a               = "==== Trailing Stop ====";
extern bool UsarTrailingStop           = false;
input double Trailingstop = 50;

extern string EA_Texto4                = "==== Fechamento de Ordens ====";
extern bool UsarTPVirtual              = true;
extern float   TPVirtual               = 2;                           
extern bool UsarSLVirtual              = false;
extern float  SLVirtual                = 6;
extern bool UsarStopLoss               = true;
extern float pipsStopLoss              = 9;
extern bool UsarTakeProfit             = true;
extern float pipsTakeProfit            = 10;

int MagicNumber;
extern double Lots =1;
extern int Slippage=1;
extern int Start_Time=0;
extern int Finish_Time=0;

double ponto;
// globals
double MinLot, MaxLot, LotDigits, StpLvl, Range;
datetime bt = 0;
int m = 0;
int lm = -1, ld = -1;
string symb;
int periodo = -1;

int contador   = 0;
//Chart
string obj_name;
long current_chart_id;

//Init
int OnInit()
  {
//---
  symb = Symbol();
   periodo = Period();

	if(Digits%2==1) Slippage *= 10;
   
   LotDigits = MathLog(MarketInfo(symb, MODE_LOTSTEP)) / MathLog(0.1);
   MinLot = MarketInfo(symb, MODE_MINLOT);
   MaxLot = MarketInfo(symb, MODE_MAXLOT);
   StpLvl = MarketInfo(symb, MODE_STOPLEVEL);
   
   //Calculo de Ponto
   if (Point == 0.00001) ponto = 0.0001;
   else {
      if (Point == 0.001) ponto = 0.01;
      else ponto = Point;
   }
   obj_name = "label_object";
   current_chart_id = ChartID();
 
   if(!ObjectCreate(current_chart_id,obj_name,OBJ_LABEL,0,0,0))
   {
      Print("Error: can't create label! code #",GetLastError());
      return(0);
   }
     //Magic number automatico
    // Unique sting id.    
   string id = WindowExpertName() + Symbol() + Period();
    
    
   // If there isn't already a Global Variable with the id in wich search for the MagicNumber create it  
   if(!GlobalVariableCheck(id))
   {
      MagicNumber = WindowHandle(Symbol(),0);   
      GlobalVariableSet(id,MagicNumber);
   }
   else // Just get the MagicNumber for the unique id
   {
      MagicNumber = GlobalVariableGet(id);
   }
   
   //magic number end
   
   ObjectSetString(current_chart_id,obj_name,OBJPROP_TEXT, "Slope  "+" Magic="+MagicNumber);
   ObjectSetInteger(current_chart_id,obj_name,OBJPROP_COLOR,White);
   ObjectSetInteger(current_chart_id,obj_name,OBJPROP_FONTSIZE,10);
   ObjectSetInteger(current_chart_id,obj_name,OBJPROP_XDISTANCE,400);
   ObjectSetInteger(current_chart_id,obj_name,OBJPROP_YDISTANCE,0);
 //---
   return(INIT_SUCCEEDED);
  }


//+------------------------------------------------------------------+
//    expert start function
//+------------------------------------------------------------------+
int start()
{

//Entry_Logic
      //Culclate Indicator
   double SDL_Up = iCustom(NULL, 0, "Slope Direction Line Modified", period, method, price, 0, 1); //Uptrend of Previous Bar Blue Up
   double SDL_Dn = iCustom(NULL, 0, "Slope Direction Line Modified", period, method, price, 1, 1); //Dntrend of Previous Bar  Red Down
   
ModifyOrders();
// Buy and Sell Close Condition   
 for(int index=OrdersTotal()-1; index>=0; index--)
   {
   OrderSelect(index,SELECT_BY_POS,MODE_TRADES);
   if((OrderSymbol()==Symbol()) && (OrderMagicNumber()==MagicNumber))
   {
      
   
    if(OrderType()==OP_BUY && SDL_Up > SDL_Dn)
   {
      OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),Slippage,Green);
   }
   
   if(OrderType()==OP_SELL && SDL_Up < SDL_Dn)
   {
      OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),Slippage,Orange);
   }
   }
   }
   

  // Buy and Sell Open 
  double MyPoint=Point;
  if(Digits==3 || Digits==5) MyPoint=Point*10;

  if(TotalOrdersCount()==0 && AllowTradesByTime()==True) 
  {
     int result=0;

     
     if(SDL_Up < SDL_Dn) // // Here is your open buy rule
     {
        result=OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,0,0,Comentario,MagicNumber,0,Blue);
        
     }
     
     if(SDL_Up > SDL_Dn) // Sell
     {
        result=OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,0,0,Comentario,MagicNumber,0,Red); // Here is your open Sell rule
        
    }
  }
  return(0);
}


// Hour to Trade
bool AllowTradesByTime()
   {
      int Current_Time = TimeHour(TimeCurrent());
   if (Start_Time == 0) Start_Time = 24; if (Finish_Time == 0) Finish_Time = 24; if (Current_Time == 0) Current_Time = 24;
      
   if ( Start_Time < Finish_Time )
      if ( (Current_Time < Start_Time) || (Current_Time >= Finish_Time) ) return(false);
      
   if ( Start_Time > Finish_Time )
      if ( (Current_Time < Start_Time) && (Current_Time >= Finish_Time) ) return(false);
      
   return(true);
   }

// Total Orders
int TotalOrdersCount()
{
  int result=0;
  for(int i=0;i<OrdersTotal();i++)
  {
     if(OrderSelect(i,SELECT_BY_POS ,MODE_TRADES))
     {
      if (OrderMagicNumber()==MagicNumber && OrderSymbol()==Symbol()) result++;
     }
  }
  return (result);
}

//--------------------------- Indicators -----------------------------
//+------------------------------------------------------------------+
//| Slope Direction Line function                                    |
//+------------------------------------------------------------------+
string Slope()
  {
  
//Uptrend = iCustom( NULL, 0, "SlopeqDirectiontLine", period, method, price, 0, 0 ); // BUFFER 0 - LightBlue
//Dntrend = iCustom( NULL, 0, "SlopeqDirectiontLine", period, method, price, 1, 0 ); // BUFFER 1 - Tomato
  // double Up = iCustom(NULL,0,"slope-direction-line",period, method, price, 0, 0);
  // double Dn = iCustom(NULL,0,"slope-direction-line",period, method, price, 1, 0);

   //if(Up<Dn) return(1);      // Slope Direction Blue
  // if(Up>Dn) return(2);      // Slope Direction Red

   //else return(-1);
   

   
  } // End Slope
  
  // ------ Modificar ordens

void ModifyOrders()
{ 
static int ticket;
    for (int i = 0; i < OrdersTotal(); i++) {
     OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
     double stopLossPreco = OrderStopLoss();
     double sl = OrderStopLoss();
     double tp = OrderTakeProfit();
              
     if ( OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber ) 
        {
        //Trailing STOP
        if (UsarTrailingStop) {
          TrailingStop();
        }
        //TP virtual
        if (UsarTPVirtual) {
          if (OrderType() == OP_BUY) {
                          if (Bid - OrderOpenPrice() >= (TPVirtual * ponto)) {
                          OrderClose(OrderTicket(),OrderLots(),Bid,3,Yellow); } 
                          RefreshRates();
                          }
          if (OrderType() == OP_SELL) {
            if (OrderOpenPrice()- Ask >= TPVirtual * ponto) {
                            OrderClose(OrderTicket(),OrderLots(),Ask,3,Yellow); }
                            RefreshRates();
          
          }
            }
            //End TP virtual
          //SL Virtual
           if (UsarSLVirtual) {
               if (OrderType() == OP_BUY) {
                         if (OrderOpenPrice() - Bid >= SLVirtual * ponto) {
                         OrderClose(OrderTicket(),OrderLots(),Bid,3,Orange); }
                         RefreshRates(); 
                       }
                if (OrderType() == OP_SELL) {
                 if (Ask - OrderOpenPrice() >= SLVirtual * ponto) {
                               OrderClose(OrderTicket(),OrderLots(),Ask,3,Orange); }
                               RefreshRates();
                }
                         
                     }
          //END SL Virtual    
          //set hard TP & SL for last opened trade
          switch(OrderType()) {
               case OP_BUY:
               
                  if(UsarStopLoss){
                     sl = OrderOpenPrice() - (pipsStopLoss * ponto);
                  }
                  
                  if(UsarTakeProfit){
                     tp = OrderOpenPrice() + (pipsTakeProfit * ponto);
                  }
               
                  if(UsarStopLoss || UsarTakeProfit){   
                     if(OrderModify(OrderTicket(), OrderOpenPrice(), sl, tp, 0, Blue))
                       ticket = -1;
                       RefreshRates();
                  }
                  break;
               case OP_SELL:
               
                  if(UsarStopLoss){
                     sl = OrderOpenPrice() +  (pipsStopLoss * ponto);
                  }
                  
                  if(UsarTakeProfit){
                     tp = OrderOpenPrice() - (pipsTakeProfit * ponto);
                  }
                     
                  if(UsarStopLoss || UsarTakeProfit){  
                     if(OrderModify(OrderTicket(), OrderOpenPrice(), sl, tp, 0, Red))
                        ticket = -1;
                        RefreshRates();
                  }
                  break;
               default:
                  ticket = -1;
            }
        
     
         
            
          
}         
}   
   
} //End ModifyOrders
  
 //+------------------------------------------------------------------+
//| My TrailingStop                                                  |
//+------------------------------------------------------------------+
void TrailingStop()
  {
   double MyPoint=Point;
   if(Digits==3 || Digits==5) MyPoint=Point*10;

   for(int i=OrdersTotal()-1; i>=0;i--)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
         if(OrderSymbol()==Symbol())
            if(OrderMagicNumber()==MagicNumber)
               if(OrderType()==OP_BUY)
                 {
                  if(Bid-OrderOpenPrice()>Trailingstop*MyPoint)
                     if(OrderStopLoss()<Bid-Trailingstop*MyPoint)
                        int TBM=OrderModify(OrderTicket(),OrderOpenPrice(),Bid-(Trailingstop*MyPoint),OrderTakeProfit(),0,clrNONE);
                 }

      else if(OrderType()==OP_SELL)
        {
         if(OrderOpenPrice()-Ask>Trailingstop*MyPoint)
            if(OrderStopLoss()>Ask+Trailingstop*MyPoint)
               int TSM=OrderModify(OrderTicket(),OrderOpenPrice(),Ask+(Trailingstop*MyPoint),OrderTakeProfit(),0,clrNONE);
        }
     }
  }
//+------------------------------------------------------------------+
 
  //+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   ObjectDelete(obj_name);
   ObjectDelete(obj_name);
   //Alert(symb + " Finalizado"); 
  }